/*
 spector.c : spector

    Copyright (C) 2005 Risto Maki-Petays

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "types.h"
#include "wave.h"
#include "osc.h"

#define unison 512
int
main(int argc, char **argv)
{
  int s, c, b, t;
  float phase[unison], advance[unison], output;
  Sample sample;
  sample.sampleRate = 44100;
  sample.bits = 16;
  sample.channels = 1;
  sample.duration = 4;
  sample.size = (sample.sampleRate) * ((sample.bits)/8) * (sample.channels) * (sample.duration);
  sample.waveformData = malloc(sample.size);
  print_wave_header(&sample);
  for(t=0;t<unison;t++) {
    fprintf(stderr, "%f\n", 11.f * pow(2, (float)((t+1)*10) / unison));
    advance[t] = 11.f * pow(2, (float)((t+1)*10) / unison) / sample.sampleRate;
    //phase[t] = 0;
    phase[t] = (float)rand()/RAND_MAX;
  }
  for(s=0;s<sample.duration*sample.sampleRate;s++)
  {
    for(c=0;c<sample.channels;c++)
    {
      output = 0;
      for(t=0;t<unison;t++)
      {
        output += gensin(&sample, phase[t]);
      }
      output /= unison;
      switch(sample.bits)
      {
        case 8:
          output *= 127;
          //printf("%d\n", (int)output & 0xff);
          // sample.waveformData[s*sample.channels+c] = 0x7f;
          //sample.waveformData[s*sample.channels+c] = ((0xff & (char)output) + 0x7f);
          if(output > 127)
          {
            output = 127;
          } else if(output < -128)
          {
            output = -128;
          }
          sample.waveformData[s*sample.channels+c] = (0xff & (char)output) + 0x7f;
          break;
        case 16:
          output *= 32767;
          if(output > 32767)
          {
            output = 32767;
          } else if(output < -32768)
          {
            output = -32768;
          }
          sample.waveformData[2*(s*sample.channels+c)] = 0xff & (int)output;
          sample.waveformData[2*(s*sample.channels+c)+1] = (0xff00 & (int)output) >> 8;
          break;
      }
      for(t=0;t<unison;t++)
      {
        //phase[t] += 440.f * pow(2, (float)t-(unison/2)) / sample.sampleRate;
        //phase[t] += 11.f * pow(2, (float)((t+1)*10) / unison) / sample.sampleRate;
        phase[t] += advance[t];
        phase[t] = fmod(phase[t], 1);
      }
    }
  }
  fwrite(sample.waveformData, sample.size, 1, stdout);
  //printf("%d\n", sample.size);
  return 0;
}

